//+------------------------------------------------------------------+
//|                                                3 Ducks Alert.mq4 |
//|                                                            yantz |
//|                                              taszdevil@yahoo.com |
//| This is a multi-symbol indicator for                             |
//| Andy's 3 Ducks System. It can monitor                            |
//| 1 or more symbols and can be set with                            |
//| an alert.                                                        |
//+------------------------------------------------------------------+
#property copyright "yantz"
#property link      "taszdevil@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 SeaGreen

extern string allsymbol = "EURUSD,GBPUSD,AUDUSD,GBPJPY,EURJPY"; // all symbols, comma separated
extern bool SetAlert = True;

int NumOfPairs = 0;
double CrossUp[], alertTag;

int init()
{ SetIndexStyle(0, DRAW_ARROW, EMPTY,1);
  SetIndexArrow(0, 234);
  SetIndexBuffer(0, CrossUp);
  bool symcntend = False; // count the number of symbols listed
  while (!symcntend)
  { string thissymbol = StringSplit(allsymbol, ",", NumOfPairs);
    if (thissymbol == "") symcntend = True;
    else NumOfPairs++;
  }
  ObjectCreate("InfoSection",OBJ_LABEL,0,0,0);
  ObjectSet("InfoSection",OBJPROP_XDISTANCE,4);
  ObjectSet("InfoSection",OBJPROP_YDISTANCE,20);
  ObjectSetText("InfoSection","Symbol   -   H4   -   H1  -  M5",8,"Arial",White);
  for (int j=0;j<NumOfPairs;j++)
  { int startheight = 30;
    thissymbol = StringSplit(allsymbol, ",", j); // split the symbols list
    ObjectCreate("symbol"+j,OBJ_LABEL,0,0,0);
    ObjectSet("symbol"+j,OBJPROP_XDISTANCE,4);
    ObjectSet("symbol"+j,OBJPROP_YDISTANCE,startheight+j*15);
    ObjectSetText("symbol"+j,thissymbol,8,"Arial",White);
    ObjectCreate("h4"+j,OBJ_LABEL,0,0,0);
    ObjectSet("h4"+j,OBJPROP_XDISTANCE,60);
    ObjectSet("h4"+j,OBJPROP_YDISTANCE,startheight+j*15);
    ObjectCreate("h1"+j,OBJ_LABEL,0,0,0);
    ObjectSet("h1"+j,OBJPROP_XDISTANCE,90);
    ObjectSet("h1"+j,OBJPROP_YDISTANCE,startheight+j*15);
    ObjectCreate("m5"+j,OBJ_LABEL,0,0,0);
    ObjectSet("m5"+j,OBJPROP_XDISTANCE,120);
    ObjectSet("m5"+j,OBJPROP_YDISTANCE,startheight+j*15);
  }
  return(0);
}

int deinit()
{ ObjectDelete("InfoSection");
  for (int j=0;j<10;j++)
  { ObjectDelete("symbol"+j);
    ObjectDelete("h4"+j);
    ObjectDelete("h1"+j);
    ObjectDelete("m5"+j);
  }
  return(0);
}

int start()
{ string h4txt, h1txt, m5txt;
  color h4clr, h1clr, m5clr;
  
  for (int i=0;i<NumOfPairs;i++)
  { string thissymbol = StringSplit(allsymbol, ",", i); // split the symbols list
    double sma60h4 = iMA(thissymbol,PERIOD_H4,60,0,MODE_SMA,PRICE_CLOSE,0);
    double sma60h1 = iMA(thissymbol,PERIOD_H1,60,0,MODE_SMA,PRICE_CLOSE,0);
    double sma60m51 = iMA(thissymbol,PERIOD_M5,60,0,MODE_SMA,PRICE_CLOSE,0);
    double sma60m52 = iMA(thissymbol,PERIOD_M5,60,0,MODE_SMA,PRICE_CLOSE,1);
    
    if (iClose(thissymbol,PERIOD_H4,0) > sma60h4)
    { h4txt = "bull";
      h4clr = Green;
    }
    else
    { h4txt = "bear";
      h4clr = Red;
    }
    if (iClose(thissymbol,PERIOD_H1,0) > sma60h1)
    { h1txt = "bull";
      h1clr = Green;
    }
    else
    { h1txt = "bear";
      h1clr = Red;
    }
    if (iClose(thissymbol,PERIOD_M5,0) > sma60m51)
    { m5txt = "bull";
      m5clr = Green;
    }
    else
    { m5txt = "bear";
      m5clr = Red;
    }
    ObjectSetText("h4"+i,h4txt,8,"Arial",h4clr);
    ObjectSetText("h1"+i,h1txt,8,"Arial",h1clr);
    ObjectSetText("m5"+i,m5txt,8,"Arial",m5clr);
    if (SetAlert && alertTag != iTime(thissymbol,PERIOD_M5,0))
    { if (h4txt == "bull" && h1txt == "bull" && m5txt == "bull" && iHigh(thissymbol,PERIOD_M5,1) < sma60m52)
      { Alert("Bull trend on all 3 TF for ",thissymbol);
        alertTag = iTime(thissymbol,PERIOD_M5,0);
      }
      else if (h4txt == "bear" && h1txt == "bear" && m5txt == "bear" && iLow(thissymbol,PERIOD_M5,1) > sma60m52)
      { Alert("Bear trend on all 3 TF for ",thissymbol);
        alertTag = iTime(thissymbol,PERIOD_M5,0);
      }
    }
  }
  CrossUp[0] = 0;
  return(0);
}

string StringSplit(string inputstr ,string sep, int index) // split string function by irusoh1 from http://www.metaquotes.com
{ int count=0, oldpos=0, pos=StringFind(inputstr,sep,0);
  while(pos>=0&&count<=index)
  { if(count==index)
    { if(pos==oldpos) return("");
      else return(StringSubstr(inputstr,oldpos,pos-oldpos));
    }
    oldpos=pos+StringLen(sep);
    pos=StringFind(inputstr,sep,oldpos);
    count++;
  }
  if(count==index) return(StringSubstr(inputstr,oldpos));
  return("");
}